---
title: Firefox 19 for developers
slug: Mozilla/Firefox/Releases/19
tags:
  - Firefox
  - Firefox 19
  - NeedsContent
---
<div>{{FirefoxSidebar}}</div><p>Firefox 19 was released on February 19, 2013. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li><code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Map" title="JavaScript/Reference/Global_Objects/Map">Map</a></code> and <code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Set" title="JavaScript/Reference/Global_Objects/Set">Set</a></code> objects have changed from having a <code>size()</code> method to a <code>size</code> property ({{bug("807001")}})</li>
 <li><code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Map" title="JavaScript/Reference/Global_Objects/Map">Map</a></code> and <code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/Set" title="JavaScript/Reference/Global_Objects/Set">Set</a></code> objects also have a clear() method now. ({{bug("805003")}})</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Support for the viewport-relative {{cssxref("&lt;length&gt;")}} units, <code>vh</code>, <code>vw</code>, <code>vmin</code>, and <code>vmax</code>, has landed ({{bug("503720")}})</li>
 <li>CSS Flexbox has been unprefixed, but remains disabled by default ({{bug("801098")}}).</li>
 <li>The <code>-moz-initial</code> value has been unprefixed ({{bug("806068")}}). <code>-moz-initial</code> will be kept for a while as an alias; however, authors are strongly encouraged to switch over to <code>initial</code>.</li>
 <li>The CSS {{cssxref("text-transform")}} property now supports the <code>full-width</code> keyword, which allows a more seamless inclusion of Latin characters in text using ideographic fixed-width characters, like Chinese or Japanese ({{bug("774560")}}).</li>
 <li>The CSS {{cssxref("page-break-inside")}} has been implemented ({{bug("685012")}}).</li>
 <li>The CSS {{cssxref("calc", "calc()")}} function can now be used on <code>&lt;color-stop&gt;</code> (on {{cssxref("&lt;gradient&gt;")}}).</li>
 <li>The CSS {{cssxref("@page")}} at-rule is now supported ({{bug("115199")}}). Note that the pseudo-classes {{cssxref(":first")}}, {{cssxref(":right")}}, and {{cssxref(":left")}} are not yet implemented.</li>
 <li>The {{cssxref(":-moz-placeholder")}} pseudo-class is replaced by the {{cssxref("::-moz-placeholder")}} pseudo-<em>element</em> ({{bug("737786")}}).</li>
 <li>Declarations qualified with <code>!important</code> appearing in {{cssxref("@keyframes")}} are now ignored, per spec ({{bug(784466)}}).</li>
</ul>

<h3 id="DOMAPIs">DOM/APIs</h3>

<ul>
 <li>The {{domxref("Element.getElementsByTagName")}}, {{domxref("Element.getElementsByTagNameNS")}} and {{domxref("Element.getElementsByClassName")}} methods now return a live {{domxref("HTMLCollection")}} ({{bug("799464")}}).</li>
 <li>The {{domxref("File")}} <code>mozLastModifiedDate</code> property has been implemented. ({{bug("793955")}})</li>
 <li>The {{domxref("File")}} lastModifiedDate property returns the current date, when the date of the last modification is unknown. ({{bug("793459")}}</li>
 <li>The {{domxref("CanvasRenderingContext2D")}} <code>isPointInStroke</code> method has been implemented ({{bug("803124")}}).</li>
 <li>The {{domxref("HTMLCanvasElement")}} <code>toBlob</code> method has been implemented ({{bug("648610")}}).</li>
 <li>The {{domxref("Node.isSupported")}} and the {{domxref("document.implementation", "document.implementation.hasFeature()")}} methods have been changed to always return <code>true</code> ({{bug("801425")}}).</li>
 <li>When calling <code>document.createElement(null)</code>, <code>null</code> will now be stringified and works like <code>document.createElement("null")</code>.</li>
 <li>The {{domxref("TextDecoder")}} and {{domxref("TextEncoder")}} interfaces have been updated to match the latest spec ({{bug("801487")}}).</li>
</ul>

<h3 id="XForms">XForms</h3>

<p>Support for <a href="/en-US/docs/XForms" title="XForms">XForms</a> has been <a href="http://www.philipp-wagner.com/blog/2011/07/the-future-of-mozilla-xforms/"><strong>removed</strong></a> in Firefox 19.</p>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<div class="note">
<p><strong>Note:</strong> A key change in Firefox 19 is that <a href="/en-US/docs/XPCOM_API_Reference/nsresult" title="XPCOM_API_Reference/nsresult"><code>nsresult</code></a> is now strongly typed. This will help make it easier to detect bugs that are caused by mishandling of return values, but may cause existing code to break if it's making incorrect assumptions in this regard.</p>
</div>

<ul>
 <li><code>getBrowserSelection()</code> now returns the selected text in a text input field. As a result, <code>gContextMenu.isTextSelected</code> will be <code>true</code> when the user selects text in a text input field that is not a password field. ({{bug("565717")}})</li>
 <li><a href="/en-US/docs/Mozilla/JavaScript_code_modules/Dict.jsm" title="Mozilla/JavaScript_code_modules/Dict.jsm">Dict.jsm</a>: <a href="/en-US/docs/Mozilla/JavaScript_code_modules/Dict.jsm#Creating_a_dictionary" title="Mozilla/JavaScript_code_modules/Dict.jsm#Creating_a_dictionary"><code>Dict()</code></a> now takes a JSON String. <a href="/en-US/docs/Mozilla/JavaScript_code_modules/Dict.jsm#toJSON()" title="Mozilla/JavaScript_code_modules/Dict.jsm#toJSON()"><code>Dict.toJSON()</code></a> was added, and it returns a JSON String. ({{bug("727967")}})</li>
</ul>

<h3 id="Interface_changes">Interface changes</h3>

<dl>
 <dt>{{interface("nsIImgLoadingContent")}}</dt>
 <dd>The parameter (aObserver) of <code>addObserver()</code> method changes from {{interface("imgIDecoderObserver")}} to {{interface("imgINotificationObserver")}}. The <code>notify()</code> method of {{interface("imgINotificationObserver")}} is not scriptable, so you need to use <code>createScriptedObserver()</code> from {{interface("imgITools")}}.</dd>
 <dt>{{interface("nsIChannel")}}</dt>
 <dd>The property <code>contentLength</code> changed from <code>long</code> to <code>int64_t</code>.</dd>
</dl>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.mozilla.org/en-US/firefox/19.0beta/releasenotes/">Firefox 19 Beta Release Notes</a></li>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/19/">Site Compatibility for Firefox 19</a></li>
 <li><a href="https://blog.mozilla.org/addons/2013/02/07/compatibility-for-firefox-19/">Add-on Compatibility for Firefox 19</a></li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<div>{{Firefox_for_developers('18')}}</div>
